unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, NPCAI;

type
  TForm1 = class(TForm)
    Shape1: TShape;
    Shape2: TShape;
    Timer1: TTimer;
    Shape3: TShape;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure AIEvent(var aX: Extended; var aY: Extended; var aSpeed: Extended);
  private
    { Private declarations }
  public
    { Public declarations }
    HorAI: THorisontalNPCAI;
    CircleAI: TCircleNPCAI;
    CustAI: TCustomNPCAI;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AIEvent(var aX, aY, aSpeed: Extended);
begin
  if CircleAI.X > aX then aX := aX + aSpeed;
  if CircleAI.X < aX then aX := aX - aSpeed;
  if CircleAI.Y > aY then aY := aY + aSpeed;
  if CircleAI.Y < aY then aY := aY - aSpeed;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  CircleAI := TCircleNPCAI.Create(200, 200, 100, 0, 2);
  HorAI := THorisontalNPCAI.Create(50, 200, 30, 350, 1);
  CustAI := TCustomNPCAI.Create(20, 20, 3);
  CustAI.OnTick := AIEvent;
  Shape1.Left := HorAI.IntX;
  Shape1.Top := HorAI.IntY;
  Shape2.Left := CircleAI.IntX;
  Shape2.Top := CircleAI.IntY;
  Shape3.Left := CustAI.IntX;
  Shape3.Top := CustAI.IntY;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  HorAI.Free;
  CircleAI.Free;
  CustAI.Free;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  HorAI.Tick;
  CircleAI.Tick;
  CustAI.Tick;
  Shape1.Left := HorAI.IntX;
  Shape1.Top := HorAI.IntY;
  Shape2.Left := CircleAI.IntX;
  Shape2.Top := CircleAI.IntY;
  Shape3.Left := CustAI.IntX;
  Shape3.Top := CustAI.IntY;
end;

end.
